package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type OrgDivision struct {
	api.Api
}

// GetPage 获取OrgDivision列表
// @Summary 获取OrgDivision列表
// @Description 获取OrgDivision列表
// @Tags OrgDivision
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.OrgDivision}} "{"code": 200, "data": [...]}"
// @Router /api/v1/org-division [get]
// @Security Bearer
func (e OrgDivision) GetPage(c *gin.Context) {
    req := dto.OrgDivisionGetPageReq{}
    s := service.OrgDivision{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.OrgDivision, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取OrgDivision 失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取OrgDivision
// @Summary 获取OrgDivision
// @Description 获取OrgDivision
// @Tags OrgDivision
// @Param id path string false "id"
// @Success 200 {object} response.Response{data=models.OrgDivision} "{"code": 200, "data": [...]}"
// @Router /api/v1/org-division/{id} [get]
// @Security Bearer
func (e OrgDivision) Get(c *gin.Context) {
	req := dto.OrgDivisionGetReq{}
	s := service.OrgDivision{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.OrgDivision

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取OrgDivision失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建OrgDivision
// @Summary 创建OrgDivision
// @Description 创建OrgDivision
// @Tags OrgDivision
// @Accept application/json
// @Product application/json
// @Param data body dto.OrgDivisionInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/org-division [post]
// @Security Bearer
func (e OrgDivision) Insert(c *gin.Context) {
    req := dto.OrgDivisionInsertReq{}
    s := service.OrgDivision{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建OrgDivision  失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改OrgDivision
// @Summary 修改OrgDivision
// @Description 修改OrgDivision
// @Tags OrgDivision
// @Accept application/json
// @Product application/json
// @Param data body dto.OrgDivisionUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/org-division/{id} [put]
// @Security Bearer
func (e OrgDivision) Update(c *gin.Context) {
    req := dto.OrgDivisionUpdateReq{}
    s := service.OrgDivision{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改OrgDivision 失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除OrgDivision
// @Summary 删除OrgDivision
// @Description 删除OrgDivision
// @Tags OrgDivision
// @Param ids body []int false "ids"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/org-division [delete]
// @Security Bearer
func (e OrgDivision) Delete(c *gin.Context) {
    s := service.OrgDivision{}
    req := dto.OrgDivisionDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除OrgDivision失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}